import { ɵɵdefineInjectable, ɵsetClassMetadata, Injectable, ɵɵdirectiveInject, ɵɵdefineComponent, ɵɵelement, Component, ChangeDetectionStrategy, InjectionToken, ɵɵelementStart, ɵɵtext, ɵɵelementEnd, ɵɵadvance, ɵɵproperty, ɵɵpureFunction0, ɵɵtextInterpolate, Inject, ɵɵnextContext, ɵɵtemplate, ɵɵelementContainerStart, ɵɵpipe, ɵɵelementContainerEnd, ɵɵpipeBind1, ɵɵlistener, ɵɵtemplateRefExtractor, ɵɵreference, ɵɵdefinePipe, Pipe, Optional, ɵɵgetCurrentView, ɵɵrestoreView, ɵɵclassProp, ɵɵsanitizeHtml, ɵɵnamespaceSVG, ɵɵnamespaceHTML, ɵɵNgOnChangesFeature, Input, ɵɵpropertyInterpolate, ChangeDetectorRef, ɵɵdefineNgModule, ɵɵdefineInjector, ɵɵsetNgModuleScope, NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
import { Title, DomSanitizer } from '@angular/platform-browser';
import { BehaviorSubject, of } from 'rxjs';
import { RouterOutlet, ActivatedRoute, RouterLinkWithHref, RouterLink, RouterModule } from '@angular/router';
import { NgIf, NgForOf, KeyValuePipe, AsyncPipe, NgClass, CommonModule } from '@angular/common';
import { switchMap } from 'rxjs/operators';

var DocsService = /** @class */ (function () {
    function DocsService() {
        this._menuItems$ = new BehaviorSubject(null);
    }
    Object.defineProperty(DocsService.prototype, "menuItems$", {
        get: function () {
            return this._menuItems$.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocsService.prototype, "menuItems", {
        set: function (items) {
            this._menuItems = items;
            this._menuItems$.next(items);
        },
        enumerable: true,
        configurable: true
    });
    /** @nocollapse */ DocsService.ɵfac = function DocsService_Factory(t) { return new (t || DocsService)(); };
    /** @nocollapse */ DocsService.ɵprov = ɵɵdefineInjectable({ token: DocsService, factory: DocsService.ɵfac, providedIn: 'root' });
    return DocsService;
}());
/*@__PURE__*/ (function () { ɵsetClassMetadata(DocsService, [{
        type: Injectable,
        args: [{ providedIn: 'root' }]
    }], null, null); })();

var baseTitle = function (title) {
    return title.includes('|') ? title.split(' | ')[0] : title;
};
var titleFromName = function (name) {
    return name.split(/(?=[A-Z])/).join(' ');
};
var titleFromTag = function (tag) {
    return tag.split('-').slice(1).map(function (word) { return word.charAt(0).toUpperCase() + word.slice(1); }).join(' ');
};

var ApiComponent = /** @class */ (function () {
    function ApiComponent(title, service) {
        this.title = title;
        this.service = service;
        this.service.menuItems = undefined;
        this.title.setTitle(baseTitle(this.title.getTitle()) + " | API");
    }
    /** @nocollapse */ ApiComponent.ɵfac = function ApiComponent_Factory(t) { return new (t || ApiComponent)(ɵɵdirectiveInject(Title), ɵɵdirectiveInject(DocsService)); };
    /** @nocollapse */ ApiComponent.ɵcmp = ɵɵdefineComponent({ type: ApiComponent, selectors: [["ng-component"]], decls: 1, vars: 0, template: function ApiComponent_Template(rf, ctx) { if (rf & 1) {
            ɵɵelement(0, "router-outlet");
        } }, directives: [RouterOutlet], encapsulation: 2, changeDetection: 0 });
    return ApiComponent;
}());
/*@__PURE__*/ (function () { ɵsetClassMetadata(ApiComponent, [{
        type: Component,
        args: [{
                template: '<router-outlet></router-outlet>',
                changeDetection: ChangeDetectionStrategy.OnPush
            }]
    }], function () { return [{ type: Title }, { type: DocsService }]; }, null); })();

var FrameworkType;
(function (FrameworkType) {
    FrameworkType["angular"] = "angular";
    FrameworkType["javascript"] = "javascript";
    FrameworkType["vue"] = "vue";
})(FrameworkType || (FrameworkType = {}));
var DEMO_COMPONENTS = new InjectionToken('Demo components');
var GET_STARTED_URL = new InjectionToken('URL to get started from home');
var HOME_README = new InjectionToken('Injectable Home Readme');
var LIBRARY_API = new InjectionToken('The full library API');
var MODULE_DOCS = new InjectionToken('Demo components');
var MODULE_GET_STARTED_URL = new InjectionToken('URL to try a module');
var MODULE_NAME = new InjectionToken('Module name');
var MODULE_README = new InjectionToken('Injectable Web Components Readme');
var MODULE_TYPE = new InjectionToken('The framework the module is for');

var _c0 = function () { return ["../../"]; };
var ApiDocComponent = /** @class */ (function () {
    function ApiDocComponent(title, route, api) {
        var _this = this;
        this.title = title;
        this.route = route;
        var module = this.route.snapshot.paramMap.get('module');
        this.id = this.route.snapshot.paramMap.get('id');
        this.doc = api[module].find(function (d) { return d.tag ? d.tag === _this.id : d.name === _this.id; });
        this.title.setTitle(baseTitle(this.title.getTitle()) + " | " + this.id);
    }
    /** @nocollapse */ ApiDocComponent.ɵfac = function ApiDocComponent_Factory(t) { return new (t || ApiDocComponent)(ɵɵdirectiveInject(Title), ɵɵdirectiveInject(ActivatedRoute), ɵɵdirectiveInject(LIBRARY_API)); };
    /** @nocollapse */ ApiDocComponent.ɵcmp = ɵɵdefineComponent({ type: ApiDocComponent, selectors: [["ng-component"]], decls: 10, vars: 5, consts: [[1, "component-readme"], [1, "breadcrumbs"], [3, "routerLink"], [1, "sep"], [1, "id"], [3, "data"], [3, "doc"]], template: function ApiDocComponent_Template(rf, ctx) { if (rf & 1) {
            ɵɵelementStart(0, "article", 0);
            ɵɵelementStart(1, "div", 1);
            ɵɵelementStart(2, "a", 2);
            ɵɵtext(3, "API");
            ɵɵelementEnd();
            ɵɵelementStart(4, "span", 3);
            ɵɵtext(5, "/");
            ɵɵelementEnd();
            ɵɵelementStart(6, "span", 4);
            ɵɵtext(7);
            ɵɵelementEnd();
            ɵɵelementEnd();
            ɵɵelement(8, "ad-markdown", 5);
            ɵɵelement(9, "ad-api", 6);
            ɵɵelementEnd();
        } if (rf & 2) {
            ɵɵadvance(2);
            ɵɵproperty("routerLink", ɵɵpureFunction0(4, _c0));
            ɵɵadvance(5);
            ɵɵtextInterpolate(ctx.id);
            ɵɵadvance(1);
            ɵɵproperty("data", ctx.doc.readme);
            ɵɵadvance(1);
            ɵɵproperty("doc", ctx.doc);
        } }, directives: [RouterLinkWithHref], styles: ["[_nghost-%COMP%]{display:block}[_nghost-%COMP%]   .breadcrumbs[_ngcontent-%COMP%]{margin-bottom:1rem}[_nghost-%COMP%]   .breadcrumbs[_ngcontent-%COMP%]   .sep[_ngcontent-%COMP%]{color:var(--anj-border-dark);margin:0 .5rem}[_nghost-%COMP%]   .breadcrumbs[_ngcontent-%COMP%]   .id[_ngcontent-%COMP%]{color:var(--anj-neutral)}"], changeDetection: 0 });
    return ApiDocComponent;
}());
/*@__PURE__*/ (function () { ɵsetClassMetadata(ApiDocComponent, [{
        type: Component,
        args: [{
                templateUrl: './api-doc.component.html',
                styleUrls: ['./api-doc.component.scss'],
                changeDetection: ChangeDetectionStrategy.OnPush
            }]
    }], function () { return [{ type: Title }, { type: ActivatedRoute }, { type: undefined, decorators: [{
                type: Inject,
                args: [LIBRARY_API]
            }] }]; }, null); })();

function ApiListComponent_ng_container_2_section_1_div_5_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "div", 6);
    ɵɵelementStart(1, "a", 7);
    ɵɵtext(2);
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    var doc_r6 = ctx.$implicit;
    var lib_r4 = ɵɵnextContext().$implicit;
    var ctx_r5 = ɵɵnextContext(2);
    ɵɵadvance(1);
    ɵɵproperty("routerLink", ctx_r5.apiPath(lib_r4.key, doc_r6));
    ɵɵadvance(1);
    ɵɵtextInterpolate(ctx_r5.nameFromDoc(doc_r6));
} }
function ApiListComponent_ng_container_2_section_1_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "section");
    ɵɵelementStart(1, "anj-headline");
    ɵɵelementStart(2, "h3");
    ɵɵtext(3);
    ɵɵelementEnd();
    ɵɵelementEnd();
    ɵɵelementStart(4, "div", 4);
    ɵɵtemplate(5, ApiListComponent_ng_container_2_section_1_div_5_Template, 3, 2, "div", 5);
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    var lib_r4 = ctx.$implicit;
    ɵɵadvance(3);
    ɵɵtextInterpolate(lib_r4.key);
    ɵɵadvance(2);
    ɵɵproperty("ngForOf", lib_r4.value);
} }
function ApiListComponent_ng_container_2_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementContainerStart(0);
    ɵɵtemplate(1, ApiListComponent_ng_container_2_section_1_Template, 6, 2, "section", 3);
    ɵɵpipe(2, "keyvalue");
    ɵɵelementContainerEnd();
} if (rf & 2) {
    var ctx_r0 = ɵɵnextContext();
    ɵɵadvance(1);
    ɵɵproperty("ngForOf", ɵɵpipeBind1(2, 1, ctx_r0.filtered));
} }
function ApiListComponent_ng_template_3_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "p");
    ɵɵtext(1, "No matches found.");
    ɵɵelementEnd();
} }
var ApiListComponent = /** @class */ (function () {
    function ApiListComponent(api) {
        this.api = api;
        this.filtered = this.api;
    }
    ApiListComponent.prototype.filter = function (_a) {
        var _this = this;
        var detail = _a.detail;
        var query = detail.value.toLowerCase();
        var filtered = {};
        for (var module in this.api) {
            if (this.api.hasOwnProperty(module)) {
                var mFiltered = this.api[module].filter(function (d) { return _this.nameFromDoc(d).toLowerCase().includes(query); });
                if (mFiltered.length > 0) {
                    filtered[module] = mFiltered;
                }
            }
        }
        this.filtered = Object.keys(filtered).length > 0 ? filtered : undefined;
    };
    ApiListComponent.prototype.apiPath = function (module, doc) {
        return module + "/" + this.nameFromDoc(doc);
    };
    ApiListComponent.prototype.nameFromDoc = function (doc) {
        return doc.tag ? doc.tag : doc.name;
    };
    /** @nocollapse */ ApiListComponent.ɵfac = function ApiListComponent_Factory(t) { return new (t || ApiListComponent)(ɵɵdirectiveInject(LIBRARY_API)); };
    /** @nocollapse */ ApiListComponent.ɵcmp = ɵɵdefineComponent({ type: ApiListComponent, selectors: [["ng-component"]], decls: 5, vars: 2, consts: [["placeholder", "Search", 3, "anjFilter"], [4, "ngIf", "ngIfElse"], ["noResults", ""], [4, "ngFor", "ngForOf"], [1, "row", "results-container"], ["class", "col-12 col-sm-6 col-md-4 col-lg-3 result", 4, "ngFor", "ngForOf"], [1, "col-12", "col-sm-6", "col-md-4", "col-lg-3", "result"], [3, "routerLink"]], template: function ApiListComponent_Template(rf, ctx) { if (rf & 1) {
            ɵɵelementStart(0, "anj-form-group");
            ɵɵelementStart(1, "anj-filter", 0);
            ɵɵlistener("anjFilter", function ApiListComponent_Template_anj_filter_anjFilter_1_listener($event) { return ctx.filter($event); });
            ɵɵelementEnd();
            ɵɵelementEnd();
            ɵɵtemplate(2, ApiListComponent_ng_container_2_Template, 3, 3, "ng-container", 1);
            ɵɵtemplate(3, ApiListComponent_ng_template_3_Template, 2, 0, "ng-template", null, 2, ɵɵtemplateRefExtractor);
        } if (rf & 2) {
            var _r1 = ɵɵreference(4);
            ɵɵadvance(2);
            ɵɵproperty("ngIf", ctx.filtered)("ngIfElse", _r1);
        } }, directives: [NgIf, NgForOf, RouterLinkWithHref], pipes: [KeyValuePipe], styles: ["[_nghost-%COMP%]{display:block}[_nghost-%COMP%]   anj-headline[_ngcontent-%COMP%]{border-bottom:1px solid var(--anj-border);padding-bottom:.75rem;margin-bottom:1rem}[_nghost-%COMP%]   .results-container[_ngcontent-%COMP%]{margin-bottom:2rem}[_nghost-%COMP%]   .result[_ngcontent-%COMP%]{margin-bottom:.5rem}"], changeDetection: 0 });
    return ApiListComponent;
}());
/*@__PURE__*/ (function () { ɵsetClassMetadata(ApiListComponent, [{
        type: Component,
        args: [{
                templateUrl: './api-list.component.html',
                styleUrls: ['./api-list.component.scss'],
                changeDetection: ChangeDetectionStrategy.OnPush
            }]
    }], function () { return [{ type: undefined, decorators: [{
                type: Inject,
                args: [LIBRARY_API]
            }] }]; }, null); })();

var LIBRARY_VERSION = new InjectionToken('LibraryVersion');
var VersionPipe = /** @class */ (function () {
    function VersionPipe(version) {
        this.version = version;
    }
    VersionPipe.prototype.transform = function (value) {
        if (!this.version) {
            return value;
        }
        var val = value.default ? value.default : value;
        return val.replace(/0.0.0/g, this.version);
    };
    /** @nocollapse */ VersionPipe.ɵfac = function VersionPipe_Factory(t) { return new (t || VersionPipe)(ɵɵdirectiveInject(LIBRARY_VERSION, 8)); };
    /** @nocollapse */ VersionPipe.ɵpipe = ɵɵdefinePipe({ name: "version", type: VersionPipe, pure: true });
    return VersionPipe;
}());
/*@__PURE__*/ (function () { ɵsetClassMetadata(VersionPipe, [{
        type: Pipe,
        args: [{
                name: 'version'
            }]
    }], function () { return [{ type: undefined, decorators: [{
                type: Optional
            }, {
                type: Inject,
                args: [LIBRARY_VERSION]
            }] }]; }, null); })();

var ExternalDocComponent = /** @class */ (function () {
    function ExternalDocComponent(docs, route, version) {
        var _this = this;
        this.docs = docs;
        this.route = route;
        this.version = version;
        this.doc$ = this.route.paramMap.pipe(switchMap(function (params) { return of(version.transform(_this.docs[params.get('id')])); }));
    }
    /** @nocollapse */ ExternalDocComponent.ɵfac = function ExternalDocComponent_Factory(t) { return new (t || ExternalDocComponent)(ɵɵdirectiveInject(MODULE_DOCS), ɵɵdirectiveInject(ActivatedRoute), ɵɵdirectiveInject(VersionPipe)); };
    /** @nocollapse */ ExternalDocComponent.ɵcmp = ɵɵdefineComponent({ type: ExternalDocComponent, selectors: [["ng-component"]], decls: 2, vars: 3, consts: [[3, "data"]], template: function ExternalDocComponent_Template(rf, ctx) { if (rf & 1) {
            ɵɵelement(0, "ad-markdown", 0);
            ɵɵpipe(1, "async");
        } if (rf & 2) {
            ɵɵproperty("data", ɵɵpipeBind1(1, 1, ctx.doc$));
        } }, pipes: [AsyncPipe], encapsulation: 2, changeDetection: 0 });
    return ExternalDocComponent;
}());
/*@__PURE__*/ (function () { ɵsetClassMetadata(ExternalDocComponent, [{
        type: Component,
        args: [{
                template: '<ad-markdown [data]="doc$ | async"></ad-markdown>',
                changeDetection: ChangeDetectionStrategy.OnPush
            }]
    }], function () { return [{ type: undefined, decorators: [{
                type: Inject,
                args: [MODULE_DOCS]
            }] }, { type: ActivatedRoute }, { type: VersionPipe }]; }, null); })();

var ExternalModuleComponent = /** @class */ (function () {
    function ExternalModuleComponent(docs, name, service) {
        this.docs = docs;
        this.name = name;
        this.service = service;
        var path = name.toLowerCase();
        this.service.menuItems = Object.keys(docs).map(function (doc) {
            return {
                link: path + "/" + doc,
                name: doc.split('-').join(' ')
            };
        });
    }
    /** @nocollapse */ ExternalModuleComponent.ɵfac = function ExternalModuleComponent_Factory(t) { return new (t || ExternalModuleComponent)(ɵɵdirectiveInject(MODULE_DOCS), ɵɵdirectiveInject(MODULE_NAME), ɵɵdirectiveInject(DocsService)); };
    /** @nocollapse */ ExternalModuleComponent.ɵcmp = ɵɵdefineComponent({ type: ExternalModuleComponent, selectors: [["ng-component"]], decls: 1, vars: 0, template: function ExternalModuleComponent_Template(rf, ctx) { if (rf & 1) {
            ɵɵelement(0, "router-outlet");
        } }, directives: [RouterOutlet], encapsulation: 2, changeDetection: 0 });
    return ExternalModuleComponent;
}());
/*@__PURE__*/ (function () { ɵsetClassMetadata(ExternalModuleComponent, [{
        type: Component,
        args: [{
                template: '<router-outlet></router-outlet>',
                changeDetection: ChangeDetectionStrategy.OnPush
            }]
    }], function () { return [{ type: undefined, decorators: [{
                type: Inject,
                args: [MODULE_DOCS]
            }] }, { type: undefined, decorators: [{
                type: Inject,
                args: [MODULE_NAME]
            }] }, { type: DocsService }]; }, null); })();

function UseCaseComponent_anj_card_1_anj_tab_11_Template(rf, ctx) { if (rf & 1) {
    var _r6 = ɵɵgetCurrentView();
    ɵɵelementStart(0, "anj-tab", 11);
    ɵɵlistener("click", function UseCaseComponent_anj_card_1_anj_tab_11_Template_anj_tab_click_0_listener() { ɵɵrestoreView(_r6); var t_r4 = ctx.$implicit; var ctx_r5 = ɵɵnextContext(2); return ctx_r5.switchTabs(t_r4.key); });
    ɵɵtext(1);
    ɵɵelementEnd();
} if (rf & 2) {
    var t_r4 = ctx.$implicit;
    var ctx_r1 = ɵɵnextContext(2);
    ɵɵclassProp("anj-active", t_r4.key === ctx_r1.activeTab);
    ɵɵadvance(1);
    ɵɵtextInterpolate(ctx_r1.codeType(t_r4.key));
} }
function UseCaseComponent_anj_card_1_ad_markdown_14_Template(rf, ctx) { if (rf & 1) {
    ɵɵelement(0, "ad-markdown", 0);
} if (rf & 2) {
    var t_r7 = ctx.$implicit;
    var ctx_r2 = ɵɵnextContext(2);
    ɵɵclassProp("anj-active", t_r7.key === ctx_r2.activeTab);
    ɵɵproperty("data", t_r7.value);
} }
function UseCaseComponent_anj_card_1_div_16_Template(rf, ctx) { if (rf & 1) {
    ɵɵelement(0, "div", 12);
} if (rf & 2) {
    var ctx_r3 = ɵɵnextContext(2);
    ɵɵproperty("innerHTML", ctx_r3.demo, ɵɵsanitizeHtml);
} }
function UseCaseComponent_anj_card_1_Template(rf, ctx) { if (rf & 1) {
    var _r9 = ɵɵgetCurrentView();
    ɵɵelementStart(0, "anj-card", 2);
    ɵɵelementStart(1, "anj-card-header");
    ɵɵelementStart(2, "anj-headline");
    ɵɵelementStart(3, "h3");
    ɵɵtext(4);
    ɵɵelementEnd();
    ɵɵelementStart(5, "anj-button", 3);
    ɵɵlistener("click", function UseCaseComponent_anj_card_1_Template_anj_button_click_5_listener() { ɵɵrestoreView(_r9); var ctx_r8 = ɵɵnextContext(); return ctx_r8.switchTabs(); });
    ɵɵnamespaceSVG();
    ɵɵelementStart(6, "svg", 4);
    ɵɵelement(7, "path", 5);
    ɵɵelementEnd();
    ɵɵelementEnd();
    ɵɵelementEnd();
    ɵɵelementEnd();
    ɵɵnamespaceHTML();
    ɵɵelementStart(8, "anj-card-body");
    ɵɵelementStart(9, "div", 6);
    ɵɵelementStart(10, "anj-tabs");
    ɵɵtemplate(11, UseCaseComponent_anj_card_1_anj_tab_11_Template, 2, 3, "anj-tab", 7);
    ɵɵpipe(12, "keyvalue");
    ɵɵelementEnd();
    ɵɵelementStart(13, "div", 8);
    ɵɵtemplate(14, UseCaseComponent_anj_card_1_ad_markdown_14_Template, 1, 3, "ad-markdown", 9);
    ɵɵpipe(15, "keyvalue");
    ɵɵelementEnd();
    ɵɵelementEnd();
    ɵɵtemplate(16, UseCaseComponent_anj_card_1_div_16_Template, 1, 1, "div", 10);
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    var ctx_r0 = ɵɵnextContext();
    ɵɵadvance(4);
    ɵɵtextInterpolate(ctx_r0.getTitle(ctx_r0.doc));
    ɵɵadvance(5);
    ɵɵclassProp("anj-active", ctx_r0.activeTab);
    ɵɵadvance(2);
    ɵɵproperty("ngForOf", ɵɵpipeBind1(12, 6, ctx_r0.tabs));
    ɵɵadvance(3);
    ɵɵproperty("ngForOf", ɵɵpipeBind1(15, 8, ctx_r0.tabs));
    ɵɵadvance(2);
    ɵɵproperty("ngIf", ctx_r0.demo);
} }
var UseCaseComponent = /** @class */ (function () {
    function UseCaseComponent(sanitizer) {
        this.sanitizer = sanitizer;
    }
    UseCaseComponent.prototype.ngOnChanges = function () {
        var docs = this.usage.split('<!-- Demo -->');
        this.doc = docs[0].trim();
        this.demo = docs[1] ? this.sanitizer.bypassSecurityTrustHtml(docs[1] ? docs[1].trim() : '') : undefined;
        if (docs[2]) {
            var tabs_1 = {};
            docs[2].trim().split('```').forEach(function (s) {
                s = s.trim();
                if (s) {
                    tabs_1[s.split(/\n/)[0].trim()] = "" + '```' + s + '```';
                }
            });
            this.tabs = tabs_1;
        }
    };
    UseCaseComponent.prototype.switchTabs = function (tab) {
        this.activeTab = tab ? tab : this.activeTab ? undefined : Object.keys(this.tabs)[0];
    };
    UseCaseComponent.prototype.getTitle = function (doc) {
        return doc.split('\n')[0].replace(/#/g, '').trim();
    };
    UseCaseComponent.prototype.codeType = function (type) {
        return type.includes('typescript') ? 'ts' : type;
    };
    /** @nocollapse */ UseCaseComponent.ɵfac = function UseCaseComponent_Factory(t) { return new (t || UseCaseComponent)(ɵɵdirectiveInject(DomSanitizer)); };
    /** @nocollapse */ UseCaseComponent.ɵcmp = ɵɵdefineComponent({ type: UseCaseComponent, selectors: [["ad-use-case"]], inputs: { usage: "usage" }, features: [ɵɵNgOnChangesFeature], decls: 2, vars: 2, consts: [[3, "data"], ["elevation", "1", 4, "ngIf"], ["elevation", "1"], ["context", "icon", "title", "View Source", 3, "click"], ["slot", "icon-only", "xmlns", "http://www.w3.org/2000/svg", "width", "24", "height", "24", "viewBox", "0 0 24 24"], ["d", "M9.4 16.6L4.8 12l4.6-4.6L8 6l-6 6 6 6 1.4-1.4zm5.2 0l4.6-4.6-4.6-4.6L16 6l6 6-6 6-1.4-1.4z"], [1, "example-container"], [3, "anj-active", "click", 4, "ngFor", "ngForOf"], [1, "example"], [3, "data", "anj-active", 4, "ngFor", "ngForOf"], ["class", "demo-container", 3, "innerHTML", 4, "ngIf"], [3, "click"], [1, "demo-container", 3, "innerHTML"]], template: function UseCaseComponent_Template(rf, ctx) { if (rf & 1) {
            ɵɵelement(0, "ad-markdown", 0);
            ɵɵtemplate(1, UseCaseComponent_anj_card_1_Template, 17, 10, "anj-card", 1);
        } if (rf & 2) {
            ɵɵproperty("data", ctx.doc);
            ɵɵadvance(1);
            ɵɵproperty("ngIf", ctx.demo);
        } }, directives: [NgIf, NgForOf], pipes: [KeyValuePipe], styles: ["[_nghost-%COMP%]{border-bottom:1px solid var(--anj-border);display:block;margin-bottom:3rem;padding-bottom:3.5rem}[_nghost-%COMP%]   anj-card[_ngcontent-%COMP%]{margin-top:2rem}[_nghost-%COMP%]   anj-tab[_ngcontent-%COMP%]{text-transform:uppercase}[_nghost-%COMP%]   .example-container[_ngcontent-%COMP%]{margin:0 -1.25rem}[_nghost-%COMP%]   .example-container[_ngcontent-%COMP%]:not(.anj-active){height:0;overflow:hidden}[_nghost-%COMP%]   .example[_ngcontent-%COMP%]{background-color:var(--anj-background);border-bottom:1px solid var(--anj-border);margin:0 0 1rem;padding:1rem}[_nghost-%COMP%]   .example[_ngcontent-%COMP%]   ad-markdown[_ngcontent-%COMP%]{display:none}[_nghost-%COMP%]   .example[_ngcontent-%COMP%]   ad-markdown.anj-active[_ngcontent-%COMP%]{display:block}"], changeDetection: 0 });
    return UseCaseComponent;
}());
/*@__PURE__*/ (function () { ɵsetClassMetadata(UseCaseComponent, [{
        type: Component,
        args: [{
                selector: 'ad-use-case',
                templateUrl: './use-case.component.html',
                styleUrls: ['./use-case.component.scss'],
                changeDetection: ChangeDetectionStrategy.OnPush
            }]
    }], function () { return [{ type: DomSanitizer }]; }, { usage: [{
            type: Input
        }] }); })();

function FeatureComponent_article_4_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "article", 7);
    ɵɵelement(1, "ad-use-case", 8);
    ɵɵelementEnd();
} if (rf & 2) {
    var key_r2 = ctx.$implicit;
    var ctx_r0 = ɵɵnextContext();
    ɵɵpropertyInterpolate("id", key_r2);
    ɵɵadvance(1);
    ɵɵproperty("usage", ctx_r0.doc.usage[key_r2]);
} }
function FeatureComponent_div_6_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "div", 9);
    ɵɵelement(1, "ad-toc", 10);
    ɵɵelementEnd();
} if (rf & 2) {
    var ctx_r1 = ɵɵnextContext();
    ɵɵadvance(1);
    ɵɵproperty("docs", ctx_r1.doc.usage)("keys", ctx_r1.sortedKeys(ctx_r1.doc.usage));
} }
var FeatureComponent = /** @class */ (function () {
    function FeatureComponent(route, changeRef, title, docs, frameWorkType) {
        var _this = this;
        this.route = route;
        this.changeRef = changeRef;
        this.title = title;
        this.docs = docs;
        this.frameWorkType = frameWorkType;
        this.route.params.subscribe({
            next: function (params) {
                var doc = _this.docs.find(function (d) {
                    return d.tag ? d.tag === params.id : d.name === params.id;
                });
                _this.doc = _this.filterExamples(doc);
                _this.title.setTitle(_this.titleFromDoc(_this.title.getTitle()));
                _this.changeRef.markForCheck();
            }
        });
    }
    FeatureComponent.prototype.sortedKeys = function (usages) {
        var keys = Object.keys(usages);
        var firstIndex = keys.findIndex(function (k) { return k === 'usage' || k === 'angular' || k === 'vue'; });
        return keys.splice(firstIndex, 1).concat(keys);
    };
    FeatureComponent.prototype.titleFromDoc = function (title) {
        var base = baseTitle(title);
        if (!this.doc) {
            return base;
        }
        return base + " | " + (this.doc.tag ? titleFromTag(this.doc.tag) : titleFromName(this.doc.name));
    };
    FeatureComponent.prototype.filterExamples = function (doc) {
        if (this.frameWorkType === FrameworkType.angular) {
            return this.getNgExamples(doc);
        }
        else if (this.frameWorkType === FrameworkType.vue) {
            return this.getVueExamples(doc);
        }
        else if (this.frameWorkType === FrameworkType.javascript) {
            return this.getJsExamples(doc);
        }
        return doc;
    };
    // Return ng examples, if existing. Otherwise, js examples.
    FeatureComponent.prototype.getNgExamples = function (doc) {
        var usages = {};
        if (doc.usage.angular) {
            for (var u in doc.usage) {
                if (u === 'angular' || u.startsWith('ng-')) {
                    usages[u] = doc.usage[u];
                }
            }
            doc.usage = usages;
            return doc;
        }
        else {
            return this.getJsExamples(doc);
        }
    };
    // Return js examples.
    FeatureComponent.prototype.getJsExamples = function (doc) {
        var usages = {};
        for (var u in doc.usage) {
            if (u !== 'angular' && !u.startsWith('ng-') &&
                u !== 'vue' && !u.startsWith('vue-')) {
                usages[u] = doc.usage[u];
            }
        }
        doc.usage = usages;
        return doc;
    };
    // Return vue examples, if existing. Otherwise, js examples.
    FeatureComponent.prototype.getVueExamples = function (doc) {
        var usages = {};
        if (doc.usage.vue) {
            for (var u in doc.usage) {
                if (u === 'vue' || u.startsWith('vue-')) {
                    usages[u] = doc.usage[u];
                }
            }
            doc.usage = usages;
            return doc;
        }
        else {
            return this.getJsExamples(doc);
        }
    };
    /** @nocollapse */ FeatureComponent.ɵfac = function FeatureComponent_Factory(t) { return new (t || FeatureComponent)(ɵɵdirectiveInject(ActivatedRoute), ɵɵdirectiveInject(ChangeDetectorRef), ɵɵdirectiveInject(Title), ɵɵdirectiveInject(MODULE_DOCS), ɵɵdirectiveInject(MODULE_TYPE, 8)); };
    /** @nocollapse */ FeatureComponent.ɵcmp = ɵɵdefineComponent({ type: FeatureComponent, selectors: [["ng-component"]], decls: 7, vars: 5, consts: [[1, "row"], [3, "ngClass"], ["id", "overview", 1, "component-readme"], [3, "data"], [3, "id", 4, "ngFor", "ngForOf"], [3, "doc"], ["class", "d-none d-lg-flex col-lg-2 toc-wrapper", 4, "ngIf"], [3, "id"], [3, "usage"], [1, "d-none", "d-lg-flex", "col-lg-2", "toc-wrapper"], [3, "docs", "keys"]], template: function FeatureComponent_Template(rf, ctx) { if (rf & 1) {
            ɵɵelementStart(0, "div", 0);
            ɵɵelementStart(1, "div", 1);
            ɵɵelementStart(2, "article", 2);
            ɵɵelement(3, "ad-markdown", 3);
            ɵɵelementEnd();
            ɵɵtemplate(4, FeatureComponent_article_4_Template, 2, 2, "article", 4);
            ɵɵelement(5, "ad-api", 5);
            ɵɵelementEnd();
            ɵɵtemplate(6, FeatureComponent_div_6_Template, 2, 2, "div", 6);
            ɵɵelementEnd();
        } if (rf & 2) {
            ɵɵadvance(1);
            ɵɵproperty("ngClass", ctx.doc.usage ? "col-12 col-lg-10" : "col-12");
            ɵɵadvance(2);
            ɵɵproperty("data", ctx.doc.readme);
            ɵɵadvance(1);
            ɵɵproperty("ngForOf", ctx.sortedKeys(ctx.doc.usage));
            ɵɵadvance(1);
            ɵɵproperty("doc", ctx.doc);
            ɵɵadvance(1);
            ɵɵproperty("ngIf", ctx.doc.usage);
        } }, directives: [NgClass, NgForOf, NgIf, UseCaseComponent], styles: [".component-readme[_ngcontent-%COMP%]{margin-bottom:2.5rem}"], changeDetection: 0 });
    return FeatureComponent;
}());
/*@__PURE__*/ (function () { ɵsetClassMetadata(FeatureComponent, [{
        type: Component,
        args: [{
                templateUrl: './feature.component.html',
                styleUrls: ['./feature.component.scss'],
                changeDetection: ChangeDetectionStrategy.OnPush
            }]
    }], function () { return [{ type: ActivatedRoute }, { type: ChangeDetectorRef }, { type: Title }, { type: undefined, decorators: [{
                type: Inject,
                args: [MODULE_DOCS]
            }] }, { type: FrameworkType, decorators: [{
                type: Optional
            }, {
                type: Inject,
                args: [MODULE_TYPE]
            }] }]; }, null); })();

function HomeComponent_p_2_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "p", 2);
    ɵɵelementStart(1, "anj-button", 3);
    ɵɵtext(2, "Get Started");
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    var ctx_r0 = ɵɵnextContext();
    ɵɵadvance(1);
    ɵɵproperty("routerLink", ctx_r0.getStartedUrl);
} }
var HomeComponent = /** @class */ (function () {
    function HomeComponent(title, service, getStartedUrl, readme) {
        this.title = title;
        this.service = service;
        this.getStartedUrl = getStartedUrl;
        this.readme = readme;
        this.service.menuItems = null;
        this.title.setTitle(baseTitle(this.title.getTitle()));
    }
    /** @nocollapse */ HomeComponent.ɵfac = function HomeComponent_Factory(t) { return new (t || HomeComponent)(ɵɵdirectiveInject(Title), ɵɵdirectiveInject(DocsService), ɵɵdirectiveInject(GET_STARTED_URL, 8), ɵɵdirectiveInject(HOME_README)); };
    /** @nocollapse */ HomeComponent.ɵcmp = ɵɵdefineComponent({ type: HomeComponent, selectors: [["ng-component"]], decls: 3, vars: 2, consts: [[3, "data"], ["class", "text-center pt-4", 4, "ngIf"], [1, "text-center", "pt-4"], [3, "routerLink"]], template: function HomeComponent_Template(rf, ctx) { if (rf & 1) {
            ɵɵelementStart(0, "article");
            ɵɵelement(1, "ad-markdown", 0);
            ɵɵtemplate(2, HomeComponent_p_2_Template, 3, 1, "p", 1);
            ɵɵelementEnd();
        } if (rf & 2) {
            ɵɵadvance(1);
            ɵɵproperty("data", ctx.readme);
            ɵɵadvance(1);
            ɵɵproperty("ngIf", ctx.getStartedUrl);
        } }, directives: [NgIf, RouterLink], encapsulation: 2, changeDetection: 0 });
    return HomeComponent;
}());
/*@__PURE__*/ (function () { ɵsetClassMetadata(HomeComponent, [{
        type: Component,
        args: [{
                templateUrl: './home.component.html',
                changeDetection: ChangeDetectionStrategy.OnPush
            }]
    }], function () { return [{ type: Title }, { type: DocsService }, { type: undefined, decorators: [{
                type: Optional
            }, {
                type: Inject,
                args: [GET_STARTED_URL]
            }] }, { type: undefined, decorators: [{
                type: Inject,
                args: [HOME_README]
            }] }]; }, null); })();

function IntroComponent_p_3_Template(rf, ctx) { if (rf & 1) {
    ɵɵelementStart(0, "p", 2);
    ɵɵelementStart(1, "anj-button", 3);
    ɵɵtext(2, "Try It");
    ɵɵelementEnd();
    ɵɵelementEnd();
} if (rf & 2) {
    var ctx_r0 = ɵɵnextContext();
    ɵɵadvance(1);
    ɵɵproperty("routerLink", ctx_r0.getStartedUrl);
} }
var IntroComponent = /** @class */ (function () {
    function IntroComponent(title, readme, moduleName, getStartedUrl) {
        this.title = title;
        this.readme = readme;
        this.moduleName = moduleName;
        this.getStartedUrl = getStartedUrl;
        this.title.setTitle(baseTitle(this.title.getTitle()) + " | " + moduleName);
    }
    /** @nocollapse */ IntroComponent.ɵfac = function IntroComponent_Factory(t) { return new (t || IntroComponent)(ɵɵdirectiveInject(Title), ɵɵdirectiveInject(MODULE_README), ɵɵdirectiveInject(MODULE_NAME), ɵɵdirectiveInject(MODULE_GET_STARTED_URL, 8)); };
    /** @nocollapse */ IntroComponent.ɵcmp = ɵɵdefineComponent({ type: IntroComponent, selectors: [["ad-components"]], decls: 4, vars: 4, consts: [[3, "data"], ["class", "text-center pt-4", 4, "ngIf"], [1, "text-center", "pt-4"], [3, "routerLink"]], template: function IntroComponent_Template(rf, ctx) { if (rf & 1) {
            ɵɵelementStart(0, "article");
            ɵɵelement(1, "ad-markdown", 0);
            ɵɵpipe(2, "version");
            ɵɵtemplate(3, IntroComponent_p_3_Template, 3, 1, "p", 1);
            ɵɵelementEnd();
        } if (rf & 2) {
            ɵɵadvance(1);
            ɵɵproperty("data", ɵɵpipeBind1(2, 2, ctx.readme));
            ɵɵadvance(2);
            ɵɵproperty("ngIf", ctx.getStartedUrl);
        } }, directives: [NgIf, RouterLink], pipes: [VersionPipe], styles: ["[_nghost-%COMP%]  ad-markdown p[align=center]{display:none}"], changeDetection: 0 });
    return IntroComponent;
}());
/*@__PURE__*/ (function () { ɵsetClassMetadata(IntroComponent, [{
        type: Component,
        args: [{
                selector: 'ad-components',
                templateUrl: './intro.component.html',
                styleUrls: ['./intro.component.scss'],
                changeDetection: ChangeDetectionStrategy.OnPush
            }]
    }], function () { return [{ type: Title }, { type: undefined, decorators: [{
                type: Inject,
                args: [MODULE_README]
            }] }, { type: undefined, decorators: [{
                type: Inject,
                args: [MODULE_NAME]
            }] }, { type: undefined, decorators: [{
                type: Optional
            }, {
                type: Inject,
                args: [MODULE_GET_STARTED_URL]
            }] }]; }, null); })();

var JsDemo = /** @class */ (function () {
    function JsDemo(element, demo) {
        element.nativeElement.appendChild(document.createRange().createContextualFragment(demo));
    }
    return JsDemo;
}());

var AnjunaDocsModule = /** @class */ (function () {
    function AnjunaDocsModule() {
    }
    /** @nocollapse */ AnjunaDocsModule.ɵmod = ɵɵdefineNgModule({ type: AnjunaDocsModule });
    /** @nocollapse */ AnjunaDocsModule.ɵinj = ɵɵdefineInjector({ factory: function AnjunaDocsModule_Factory(t) { return new (t || AnjunaDocsModule)(); }, providers: [
            VersionPipe
        ], imports: [[
                CommonModule,
                RouterModule
            ]] });
    return AnjunaDocsModule;
}());
(function () { (typeof ngJitMode === "undefined" || ngJitMode) && ɵɵsetNgModuleScope(AnjunaDocsModule, { declarations: [ApiComponent,
        ApiDocComponent,
        ApiListComponent,
        ExternalDocComponent,
        ExternalModuleComponent,
        FeatureComponent,
        HomeComponent,
        IntroComponent,
        UseCaseComponent,
        VersionPipe], imports: [CommonModule,
        RouterModule], exports: [ApiComponent,
        ApiDocComponent,
        ApiListComponent,
        ExternalDocComponent,
        ExternalModuleComponent,
        FeatureComponent,
        HomeComponent,
        IntroComponent] }); })();
/*@__PURE__*/ (function () { ɵsetClassMetadata(AnjunaDocsModule, [{
        type: NgModule,
        args: [{
                imports: [
                    CommonModule,
                    RouterModule
                ],
                declarations: [
                    ApiComponent,
                    ApiDocComponent,
                    ApiListComponent,
                    ExternalDocComponent,
                    ExternalModuleComponent,
                    FeatureComponent,
                    HomeComponent,
                    IntroComponent,
                    UseCaseComponent,
                    VersionPipe
                ],
                exports: [
                    ApiComponent,
                    ApiDocComponent,
                    ApiListComponent,
                    ExternalDocComponent,
                    ExternalModuleComponent,
                    FeatureComponent,
                    HomeComponent,
                    IntroComponent
                ],
                entryComponents: [
                    ApiComponent,
                    ApiDocComponent,
                    ApiListComponent,
                    FeatureComponent,
                    HomeComponent,
                    IntroComponent
                ],
                providers: [
                    VersionPipe
                ],
                schemas: [
                    CUSTOM_ELEMENTS_SCHEMA
                ]
            }]
    }], null, null); })();

/* Components */

/**
 * Generated bundle index. Do not edit.
 */

export { AnjunaDocsModule, ApiComponent, ApiDocComponent, ApiListComponent, DEMO_COMPONENTS, DocsService, ExternalDocComponent, ExternalModuleComponent, FeatureComponent, FrameworkType, GET_STARTED_URL, HOME_README, HomeComponent, IntroComponent, JsDemo, LIBRARY_API, LIBRARY_VERSION, MODULE_DOCS, MODULE_GET_STARTED_URL, MODULE_NAME, MODULE_README, MODULE_TYPE, VersionPipe, baseTitle, titleFromName, titleFromTag };
//# sourceMappingURL=anjuna-angular-docs.js.map
